# Major options file for libh
# $FreeBSD: libh/Makefile.inc,v 1.23 2002/04/14 00:56:21 antoine Exp $

MAJOR_VERSION=	0
MINOR_VERSION=	0
SHLIB_MAJOR=	0
SHLIB_MINOR=	0

NOPROFILE=	yes

PREFIX?=	/usr
SHAREDIR=	${PREFIX}/share/libh
BINDIR=		${PREFIX}/bin
LIBDIR=		${PREFIX}/lib

LOCALBASE?=	/usr/local
X11BASE?=	/usr/X11R6

TCLVERSION=	8.3

CDEBUGFLAGS?=	-g
CBASEFLAGS?=	-fpic -DPIC
CTCLFLAGS?=	-I$(LOCALBASE)/include/tcl$(TCLVERSION)

COPTFLAGS?=	-pipe
CWARNFLAGS?=	-Wall

CFLAGS=		${COPTFLAGS} ${CDEBUGFLAGS} ${CTCLFLAGS} ${CBASEFLAGS}

.if defined(S)
CFLAGS+=	-I$S/include
.endif

UI_SRC=

.if !defined(NOQT)
QTINCLUDE?=	$(X11BASE)/include/qt2
UI_CFLAGS+=	-I$(QTINCLUDE) -DUSE_Qt
UI_SRC+=	HuiQt.cc \
		HuiQt_ButtonWidget.cc \
		HuiQt_ButtonsGroupWidget.cc \
		HuiQt_CheckBoxesWidget.cc \
		HuiQt_ContainerWidget.cc \
		HuiQt_DialogWidget.cc \
		HuiQt_GroupWidget.cc \
		HuiQt_InputLineWidget.cc \
		HuiQt_LabelWidget.cc \
		HuiQt_ListBoxWidget.cc \
		HuiQt_MenuBarWidget.cc \
		HuiQt_MenuButtonWidget.cc \
		HuiQt_MenuItemWidget.cc \
		HuiQt_MenuSeparatorWidget.cc \
		HuiQt_MenuSubmenuWidget.cc \
		HuiQt_ProgressIndicatorWidget.cc \
		HuiQt_RadioMenuWidget.cc \
		HuiQt_TextEditWidget.cc \
		HuiQt_TitledWidget.cc \
		HuiQt_ToplevelWidget.cc \
		HuiQt_Widget.cc \
		HuiQt_WindowWidget.cc \
		HuiQt.cd.cc HuiQtNew.cc HuiQt.m.cc
.endif

.if !defined(NOTVISION)
TVINCLUDE?=	$(LOCALBASE)/include
UI_CFLAGS+=	-I$(TVINCLUDE) -DTVision
UI_SRC+=	HuiTVision.cc \
		HuiTVision_ButtonWidget.cc \
		HuiTVision_ButtonsGroupWidget.cc \
		HuiTVision_CheckBoxesWidget.cc \
		HuiTVision_ContainerWidget.cc \
		HuiTVision_DialogWidget.cc \
		HuiTVision_GroupWidget.cc \
		HuiTVision_InputLineWidget.cc \
		HuiTVision_LabelWidget.cc \
		HuiTVision_ListBoxWidget.cc \
		HuiTVision_MenuBarWidget.cc \
		HuiTVision_MenuButtonWidget.cc \
		HuiTVision_MenuItemWidget.cc \
		HuiTVision_MenuSeparatorWidget.cc \
		HuiTVision_MenuSubmenuWidget.cc \
		HuiTVision_ProgressIndicatorWidget.cc \
		HuiTVision_RadioMenuWidget.cc \
		HuiTVision_TextEditWidget.cc \
		HuiTVision_TitledWidget.cc \
		HuiTVision_ToplevelWidget.cc \
		HuiTVision_Widget.cc \
		HuiTVision_WindowWidget.cc \
		HuiTVision.cd.cc HuiTVisionNew.cc
.endif

.include "Makefile.uitype"
