#include "Hui/HuiCallback.hh"
#include "Hui/HuiMenuItem.hh"
#include "Hui/HuiMenuSubmenu.hh"
#include "Hui/HuiWindow.hh"
#include "HuiTv/HuiTv.hh"

HuiWindow *
labels_window(Hui *hui, const Position &pos)
{
	HuiWindow *w =
		hui->window(
			"Labels Window",
			"",
			HuiRegion(Size(13, 5), pos));

	w->label("Label one", HuiRegion(Size(2, 10), Position(0, 0)));
	w->label("Label two", HuiRegion(Size(2, 10), Position(0, 1)));
	w->label("Label three", HuiRegion(Size(2, 10), Position(0, 2)));

	return w;
}

HuiWindow *
buttons_window(Hui *hui, const Position &pos)
{
	HuiWindow *w =
		hui->window(
			"Second Window",
			"",
			HuiRegion(Size(18, 8), pos));
	HuiCallback	cb;
	w->button("Button one", "default", cb, HuiRegion(0, 0, 20, 2));
	w->button("Button two", "default", cb, HuiRegion(0, 2, 20, 2));
	w->button("Button three", "default", cb, HuiRegion(0, 4, 20, 2));

	return w;
}

HuiWindow *
inputlines_window(Hui *hui, const Position &pos)
{
	HuiWindow *w =
		hui->window(
			"Second Window",
			"",
			HuiRegion(Size(20, 8), pos));
	w->inputLine("Input one", 18, "none", "", Position(0, 0));
	w->inputLine("Input two", 18, "none", "", Position(0, 2));
	w->inputLine("Input three", 18, "none", "", Position(0, 4));

	return w;
}

int
main(int argc, char *argv[])
{
	HuiTv	*hui = new HuiTv(argc, argv);

	HuiWindow *mw =
		hui->window(
			"Main Window",
			"",
			HuiRegion(Size(30, 30), Position(0, 0)));

	HuiWindow *tw =
		hui->window(
			"Third Window",
			"",
			HuiRegion(Size(30, 30), Position(60, 0)));

	HuiWindow *labels = labels_window(hui, Position(0, 35));
	HuiWindow *inputs = inputlines_window(hui, Position(40, 35));
	HuiWindow *buttons = buttons_window(hui, Position(20, 35));

	HuiMenuSubmenu	*menubar = mw->menuBar();
	HuiMenuSubmenu	*a_menu = menubar->submenu(
						"&A Menu",
						"",	/* key */
						NULL);
#if 0
	HuiMenuItem	*a_button = a_menu->button(
						"&A Button",
						"",	/* key */
						NULL,	/* callback */
						NULL);
#endif
	if (false) {
		hui->remove(mw);
	}

	hui->run();

	delete inputs;
	delete buttons;
	delete labels;
	delete tw;
	delete mw;
	delete hui;
	return 0;
}
