#! /usr/bin/tclh

set res ""

puts "Feature API conformance test"
puts "============================\n"

puts "Feature constructor argument order"

set name "test"
set vers "0.1"
set serial 2
set snap 3
set f [Feature $name $vers $serial $snap]
if {[$f name] == $name && [$f version] == $vers && [$f serial] == $serial && [$f snapshot] == $snap} {
    set res "success"
} else {
    set failure [format "failed: should be %s %s %s %s" $name $vers $serial $snap]
}
puts "print() should output \"name version serial_number snapshot\""
puts [format "print(): %s (%s)" [$f print] $res]

puts "\nConstructor input sanity checks unimplemented"

puts "\nRegular feature comparison"
puts [format "f: %s" [[set f [Feature "test" "1" 0 0]] print]]
puts [format "g: %s" [[set g [Feature "test" "2" 0 0]] print]]
if {[$g compare $f] > 0} {
    set res "success"
} else {
    set res "failed: should be 1"
}
puts [format "g ?= f: %s (%s)" [$g compare $f] $res]

puts [format "f: %s" [[set f [Feature "test" "1.1" 0 0]] print]]
puts [format "g: %s" [[set g [Feature "test" "1.2" 0 0]] print]]
if {[$g compare $f] > 0} {
    set res "success"
} else {
    set res "failed: should be 1"
}
puts [format "g ?= f: %s (%s)" [$g compare $f] $res]

puts [format "f: %s" [[set f [Feature "test" "1" 0 0]] print]]
puts [format "g: %s" [[set g [Feature "test" "1.2" 0 0]] print]]
if {[$g compare $f] > 0} {
    set res "success"
} else {
    set res "failed: should be 1"
}
puts [format "g ?= f: %s (%s)" [$g compare $f] $res]

puts [format "f: %s" [[set f [Feature "test" "2.1" 0 0]] print]]
puts [format "g: %s" [[set g [Feature "test" "10.2" 0 0]] print]]
if {[$g compare $f] > 0} {
    set res "success"
} else {
    set res "failed: should be 1"
}
puts [format "g ?= f: %s (%s)" [$g compare $f] $res]

puts "\nIdentity checking"
puts [format "f: %s" [[set f [Feature "test" "0.1" 0 0]] print]]
puts [format "u: %s" [[set u [Feature "test" "0.1" 0 0]] print]]
if { [$f compare $u] == 0 } {
    set res "success"
} else {
    set res "failed, should be 0"
}
puts [format "f ?= u: %s (%s)" [$f compare $u] $res]

puts "\nSimple SN comparison"
puts [format "f: %s" [[set f [Feature "test" "0.1" 0 0]] print]]
puts [format "u: %s" [[set u [Feature "test" "0.1" 12 0]] print]]
if {[$f compare $u] < 0} {
    set res "success"
} else {
    set res "failed: should be -1"
}
puts [format "f ?= u: %s (%s)" [$f compare $u] $res]

puts "\nPrecedence checks"

puts "\nSerial vs Snapshot"
puts [format "f: %s" [[set f [Feature "test" "0.1" 12 0]] print]]
puts [format "u: %s" [[set u [Feature "test" "0.1" 0 12]] print]]
if { [$f compare $u] > 0 } {
    set res "success"
} else {
    set res "failed, should be 1"
} 
puts [format "f ?= u: %s (%s)" [$f compare $u] $res]

puts "\nSerial vs version"
puts [format "f: %s" [[set f [Feature "test" "0.2" 12 0]] print]]
puts [format "u: %s" [[set u [Feature "test" "0.1" 13 0]] print]]
if { [$f compare $u] < 0 } {
    set res "success"
} else {
    set res "failed, should be -1"
} 
puts [format "f ?= u: %s (%s)" [$f compare $u] $res]

puts "\nSnapshot vs version"
puts [format "f: %s" [[set f [Feature "test" "0.2" 0 12]] print]]
puts [format "u: %s" [[set u [Feature "test" "0.1" 0 13]] print]]
if { [$f compare $u] < 0 } {
    set res "success"
} else {
    set res "failed, should be -1"
} 
puts [format "f ?= u: %s (%s)" [$f compare $u] $res]
