#! /usr/bin/perl -w

use strict;

sub unquote {

  foreach (@_) {
    $_ =~ s/^\"//;
    $_ =~ s/\"$//;
  }
  return @_;
}

sub trim {
  foreach (@_) {
    $_ =~ s/^\s*//;
    $_ =~ s/\s*$//;
    $_ =~ s/(\s)+/$1/g;
  }
  return @_;
}

my $class = "";

$| = 1;

my $line;
while ($line = <STDIN>) {

  last if $line eq "";
  chomp $line;

  if ($line =~ /LanguageInterface::Object::MethodDescription (\w+)::sMethods/) {
    $class = $1;
    print "Class $class auto-generated documentation\n\n";
  }

    #  print $line;
  if ($line =~ /MethodDescription\(/) {
    my $tmp_l;
    while ($tmp_l = <STDIN>) {
      if ($tmp_l eq "") {
	last;
      }
      $line .= $tmp_l;
      chomp $line;
      if ($line =~
          /MethodDescription
          # name, name, type, desc
          \((.*?),(.*?),(.*?),(.*?),.*?
          # return value
          MethodDescription::((?:Value\(.*?\))|(?:vt[^,]*)),.*?
          # arguments
          MethodDescription::((?:Value\(.*?\))|(?:vt[^,]*)).*?
          \)
          /xis) {

        my ($name, $name2, $type, $desc, $return, $args) =
          ($1, $2, $3, $4, $5, $6);
        $return =~ s/^Value\(//;
        $return =~ s/\)$//;
        my ($ret_type, $ret_name) = split (/,/, $return);
        $ret_type =~ s/(MethodDescription::)?vt//;
        $ret_name = "" if (!defined($ret_name));
        trim ($name, $name2, $type, $desc, $ret_type, $ret_name, $args);
        unquote($name, $name2, $desc);

        print 
          "\
${class}::$name $name2\
\tArguments: $args\
\treturns $ret_name: $ret_type\
\t$desc\
\n";

        last;
      }
    }
  }
}
