#ifndef HuiQtMenuSubmenu_hh_f90af722
#define HuiQtMenuSubmenu_hh_f90af722
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiQt/HuiQtMenuSubmenu.hh,v 1.2 2002/08/21 11:15:27 okumoto Exp $
 */

#include "Hui/HuiMenuSubmenu.hh"
#include "HuiQt/HuiQtMenuItem.hh"

#include <string>

class HuiCallback;
class HuiQtMenuBar;

/**
 * TVision SubMenu object.
 */
class HuiQtMenuSubmenu : virtual public HuiMenuSubmenu, public HuiQtMenuItem {
protected:
	HuiQtMenuBar		&bar;
	HuiQtMenuItems		wl;

	virtual void
	append(HuiQtMenuItem *item);

	HuiQtMenuSubmenu(
		HuiQtMenuBar &aBar);

public:
	HuiQtMenuSubmenu(
		HuiWidget *aParent,
		HuiQtMenuBar &aBar,
		const string &aText,
		const string &aKey);

	HuiMenuItem *
	button(
		const string &aText,
		const string &aKey,
		const HuiCallback &callback,
		HuiMenuItem *aBefore);

	HuiMenuItem *
	separator(
		HuiMenuItem *aBefore);

	HuiMenuSubmenu *
	submenu(
		const string &aText,
		const string &aKey,
		HuiMenuItem *aBefore);

	void
	remove(HuiMenuItem *aItem)
	{}
};

#endif /* HuiQtMenuSubmenu_hh_f90af722 */
