#ifndef HuiQtRadioMenu_hh_d9e0b72e
#define HuiQtRadioMenu_hh_d9e0b72e
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiQt/HuiQtRadioMenu.hh,v 1.2 2002/08/21 11:15:27 okumoto Exp $
 */

#include "HuiQt/HuiQtButtonsGroup.hh"
#include "Hui/HuiRadioMenu.hh"

/**
 */
class HuiQtRadioMenu : virtual public HuiRadioMenu, public HuiQtButtonsGroup {

public:
	HuiQtRadioMenu(
		HuiWidget *aParent,
		const vector<string> &aTexts,
		int aInitialValue,
		const string &aTitle,
		const vector<string> &aSVector);

	/**
	 * Destructor.
	 */
	~HuiQtRadioMenu();

	void set(int itemno);
	int set() const;

	void text(int boxno, const string &aText);
	string text(int boxno) const;

	int numberOfItems() const;
	bool item_disabled(int boxno) const;
};

#endif /* HuiQtRadioMenu_hh_d9e0b72e */
