#ifndef HuiTv_hh_c1d108a1
#define HuiTv_hh_c1d108a1
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiTv/HuiTv.hh,v 1.6 2002/08/24 09:06:29 okumoto Exp $
 */

#include "Hui/Hui.hh"

#include <list>
#include <string>

/*
 * Forward declarations.
 */
class HuiTvApplication;
class HuiTvWidget;
class HuiRegion;

/**
 * Represent a libh Turbo Vision user interface.
 */
class HuiTv : public Hui {
	typedef list<HuiTvWidget *>	WidgetList;

	WidgetList			topWidgets;
	HuiTvApplication		*app_info;

public:
	HuiTv(int argc, char *argv[]);

	~HuiTv();

	HuiWindow *
	window(
		const string &aTitle,
		const string &aAlignment,
		const HuiRegion &region);

	HuiDialog *
	dialog(
		HuiWidget *aParent,
		const string &aTitle,
		const string &aAlignment,
		const HuiRegion &region);

	string
	fileSelectionDialog(const string &title, const string &patt);

	void
	remove(HuiToplevel *toplevel);

	void run();

	void exit(int status);
};
#endif /* HuiTv_hh_c1d108a1 */
