/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiTv/HuiTvButtonsGroup.cc,v 1.38 2002/08/20 10:41:42 okumoto Exp $
 */

#include "HuiTv/HuiTvButtonsGroup.hh"

#define Uses_TCluster
#define Uses_TSItem

#include <tvision/tv.h>

HuiTvButtonsGroup::HuiTvButtonsGroup(
	HuiWidget *aParent,
	const string &aTitle,
	const vector<string> &aSVector)
    : HuiTvEmbedded(aParent),
      mComments(aSVector)
{
}

void
HuiTvButtonsGroup::disable()
{
	HuiTvEmbedded::disable();
}

void
HuiTvButtonsGroup::enable()
{
	HuiTvEmbedded::enable();
}

void
HuiTvButtonsGroup::disable_item(int boxno)
{
	if (widget()) {
		TCluster	*g = dynamic_cast<TCluster *>(widget());
		g->setButtonState(1L << boxno, False);
	}
}

void
HuiTvButtonsGroup::enable_item(int boxno)
{
	if (widget()) {
		TCluster	*g = dynamic_cast<TCluster *>(widget());
		g->setButtonState(1L << boxno, True);
	}
}

TSItem *
HuiTvButtonsGroup::strings2tsitem(const vector<string> &aTexts)
{
	assert(0);
	TSItem* result = 0;
	for (vector<string>::const_reverse_iterator s = aTexts.rbegin(); s != aTexts.rend(); ++s)
	    result = new TSItem(
		newStr(HuiTvEmbedded::translateAccel(*s).c_str()),
		result);

	return(result);
}

