#ifndef HuiTvCheckBoxes_hh_ea0438dc
#define HuiTvCheckBoxes_hh_ea0438dc
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiTv/HuiTvCheckBoxes.hh,v 1.4 2002/08/20 10:41:42 okumoto Exp $
 */

#include "Hui/HuiCheckBoxes.hh"
#include "HuiTv/HuiTvButtonsGroup.hh"

class HuiTvCheckBoxes : virtual public HuiCheckBoxes, public HuiTvButtonsGroup {
public:
	HuiTvCheckBoxes(
		HuiWidget *aParent,
		const vector<string> &aTexts,
		const vector<bool> &aInitialValues,
		const string &aTitle,
		const vector<string> &aSVector);

	~HuiTvCheckBoxes();

	bool state(int boxno, int aNewState);

	bool state(int boxno) const;
	bool toggle(int boxno);

	void text(int boxno, const string &aText);
	string text(int boxno) const;

	int numberOfItems() const;
	bool item_disabled(int boxno) const;
};

#endif /* HuiTvCheckBoxes_hh_ea0438dc */
