#ifndef HuiTvMenuItem_hh_10f97f04
#define HuiTvMenuItem_hh_10f97f04
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiTv/HuiTvMenuItem.hh,v 1.5 2002/08/22 11:14:57 okumoto Exp $
 */

#include "Hui/HuiMenuItem.hh"
#include "HuiTv/HuiTvWidget.hh"

#include <string>

class HuiWidget;
class TMenuItem;

/**
 * Base class for menu objects.
 */
class HuiTvMenuItem : virtual public HuiMenuItem, public HuiTvWidget {
protected:
	string		mText;
	string		mKey;
	TMenuItem	*mMenuItem;

	static ushort
	key2keyCode(const string &aKey);

public:
	/**
	 * Constructor.
	 */
	HuiTvMenuItem(
		HuiWidget *aParent);

	void enable();
	void disable();
	bool disabled() const;

	virtual string
	text() const
	{
		return mText;
	}

	void
	text(const string &aText);

	string
	key() const
	{
		return mKey;
	}

	/**
	 * Returns the TVision object which renders this widget.
	 */
	TMenuItem *
	mwidget() const
	{
		return mMenuItem;
	}
};

typedef list<HuiTvMenuItem *>	HuiTvMenuItems;

#endif /* HuiTvMenuItem_hh_10f97f04 */
