#ifndef HuiTvWindow_hh_820b1ab2
#define HuiTvWindow_hh_820b1ab2
/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/HuiTv/HuiTvWindow.hh,v 1.5 2002/08/22 12:34:12 okumoto Exp $
 */

#include "Hui/HuiWindow.hh"
#include "HuiTv/HuiTvToplevel.hh"

#include <string>

class Hui;
class HuiMenuSubmenu;
class HuiRegion;

/**
 * Toplevel widget which can be manipulated by the user (resized,
 * moved, closed, etc.)
 */
class HuiTvWindow : virtual public HuiWindow, public HuiTvToplevel {
public:
	HuiTvWindow(
		const string &aTitle,
		const string &aAlignment,
		const HuiRegion &region);

	~HuiTvWindow();

	HuiMenuSubmenu *menuBar();

	/**
	 * Close window is really just an alias for hide()
	 */
	inline void
	close()
	{
		hide();
	}
};

#endif /* HuiTvWindow_hh_820b1ab2 */
