/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/tcl/LibHTclInit_hui.cc,v 1.9 2002/05/05 01:23:17 okumoto Exp $
 */

// -*- C++ -*-   Thu Nov  5 1998
// Eugene Skepner <eu@qub.com>
// $Id: LibHTclInit_hui.cc,v 1.2 1998/12/02 10:58:10 eugene Exp $

#include "tcl/TclLanguageInterface.hh"
#include "hui/Hui.hh"
#include "tcl/LibHTclInit_hui.hh"

#include <tcl.h>
#include <iostream>

//======================================================================

static void register_command_access_tcl(); // generated by tcl_interface_gen in LibHTcltestInterface.cc

#include "LibTclInterface_hui.cc"

//======================================================================

extern "C" int Htclhui_Init( Tcl_Interp* interp )
{
	if ( interp == 0 )
		return(TCL_ERROR);

	register_command_access_tcl();

	return(TCL_OK);
}

//======================================================================
