/*
 * $FreeBSD: libh/release/init/system.c,v 1.5 2002/04/15 00:24:10 antoine Exp $
 * 
 * Based on Jordan Hubbard's sysinstall setup.c.
 * 
 * From src/release/sysinstall/setup.c:
 * 
 * Parts of this file are also blatently stolen from Poul-Henning Kamp's
 * previous version of sysinstall, and as such fall under his "BEERWARE
 * license" so buy him a beer if you like it!  Buy him a beer for me, too!
 * Heck, get him completely drunk and send me pictures! :-)
 */

#include <signal.h>
#include <termios.h>
#include <sys/reboot.h>
#include <sys/consio.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/sysctl.h>
#include <sys/param.h>
#include <sys/mount.h>

#include <paths.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "system.h"
#include "termcap.h"

/* Initialize system defaults */
void
systemInitialize(int argc, char **argv)
{
	int             fd, ret;

	signal(SIGINT, SIG_IGN);

	ret = mount("devfs", _PATH_DEV, MNT_NOEXEC | MNT_RDONLY, 0);
	if (ret == -1)
		exit(111);

	setsid();
	close(0);

	fd = open("/dev/ttyv0", O_RDWR);
	if (fd == -1)
		exit(5);
	close(1);
	dup(0);
	close(2);
	dup(0);

	printf("%s running as init on %s\n",
	       argv[0], "vty0");
	printf("init: ioctl TIOSCTTY\n");
	ioctl(0, TIOCSCTTY, (char *)NULL);
	setlogin("root");
	setenv("PATH", "/bin:/sbin", 1);
	setbuf(stdin, 0);
	setbuf(stderr, 0);

	if (set_termcap() == -1) {
		printf("Can't set_termcap!\n");
		exit(55);
	}
}
