#!/bin/sh
# the next line restarts using tclsh \
exec tclh "$0" "$@"

global test_window

proc disk_callback {hui foo bar} {
    global test_window
    source scripts/diskedit/disklabel.tcl
    disklabel $hui $test_window
}

proc newfs_callback {hui foo bar} {
    global test_window
    source scripts/diskedit/newfs.tcl
    newfs_win $hui $test_window
}

proc quit_callback {hui foo bar} {
    global test_window
    $test_window hide
    # this must be removed when included in another program
    $hui exit
    exit

}

set hui [Hui::open "auto"]

set menuBar [$hui menuBar]
set FileMenu [$menuBar addSubmenu b1 &File "File Comment"]
$FileMenu addButton qfm &Quit {quit_callback 0} "Alt-X" "Quit"

set test_window [$hui window "labeltest"\
                    "Partition Editor Test Loader" "1 0" "40 5" "horizontal"]

$test_window button "disk" "&Test diskeditor" {disk_callback ""} "default"
$test_window button "newfs" "&Test newfs" {newfs_callback ""} "default"
$test_window button "quit" "&Quit" {quit_callback ""}

$test_window show
$hui run