
proc button_click_result {$hui button result} {
    return $result
}


# this returns a list containing:
# type: fs or swap
# size: sectors int
proc part_create_dialog {hui parent disk slice {chunk 0}} {

    set dialog [$hui dialog $parent part_type_dialog \
                    "Create Part" "10 6" "40 7" "vertical"]

    $dialog resize "-1 1"

    # we can edit size && type only on creation
    set hcont1 [$dialog container "hcont" "0 0" "horizontal"]
    
    set type_but [$hcont1 radioMenu "part_type" {"&File System" "&Swap"} 0 "&Partition type"]
    
    set sz_cont [$hcont1 container "scont" "0 0" "vertical"]
    $sz_cont label "desc label" "Size:"
    set size_field [$sz_cont inputLine "size_field" [$slice size] 30]

    # these cannot be edited: use delete + add
#    if {$chunk != 0} {
#        $type_but disable
#        $size_field disable
#    }

    set but_cont [$dialog container "bcont" "0 0" "horizontal"]
    set ok [$but_cont button ok_button "&OK" {button_click_result OK} "default"]
    set cancel [$but_cont button cancel_button "&Cancel" {button_click_result CANCEL}]

    # set defaults to given chunk
    if {$chunk != 0} {

        $type_but set [$chunk is_swap]
        $size_field text [$chunk size]

    }

    $dialog exec
    set result [$dialog result]
    if {[string compare $result "OK"] == 0} {
        set size [$size_field text]
        if {[$type_but set] == 0} {
            set type "fs"
        } else {
            set type "swap"
        }
                
        # yes is item 0
        return [list $type $size]
    }

    return $result
}

# Returns 0 if invalid or 1 if valid
proc partition_create_check_created {hui parent new_partition disk root} {

    if [H::is_null $new_partition] {
	ok_dialog $hui $parent "Can't create" "Unable to create the partition. Too big?" "22 2"
	return 0
#
# not sure how this is possible
#
# I can't find any reference to the CHUNK_PAST_1024 keyword anywhere
#
#     } elseif {$root && [lsearch [$new_partition flags] "CHUNK_PAST_1024"] >= 0} {
# 	ok_dialog $hui $parent "Can't create" "This region cannot be used for your root partition as it starts\nor extends past the 1024'th cylinder mark and is thus a\npoor location to boot from.  Please choose another\nlocation (or smaller size) for your root partition and try again!" 22 5
# 	$disk Delete_Chunk $new_partition
# 	return 0
    }
    return 1
}

# return true if disks were modified
proc write_disks_confirm {hui parent disk_list} {

    set dialog [$hui dialog $parent "write_disks_dialog" "Write disks"\
                    "10 6" "57 10"]

    set label [$dialog label "desc label" \
                   "Please specify which disks must be written. Greyed out items were not modified."]

    foreach disk $disk_list {

        lappend disk_names [$disk name]
        lappend written [$disk modified]

    }

    set disks [$dialog checkBoxes "disks" $disk_names {FALSE}]

    # disable unwritten disk items
    for {set i 0} {$i < [llength $written]} {incr i} {
        if {![lindex $written $i]} {
            $disks disable_item $i
        }
    }

    set okbutton [$dialog button "okbutton" "&OK" {button_click_result "OK"}]
    set cancelbutton [$dialog button "cancelbutton" "&Cancel" {button_click_result "CANCEL"}]

    $label move "1 0"
    $label resize "20 1"
    $disks move "1 2"
    $disks resize [format "10 %d" [expr [llength $disk_list] + 1]]

    $okbutton move [format "1 %d" [expr [llength $disk_list] + 4]]
    $okbutton resize "10 2"
    $cancelbutton move [format "15 %d" [expr [llength $disk_list] + 4]]
    $cancelbutton resize "10 2"

    $dialog exec
    set result [$dialog result]

    if {[string compare $result "OK"] == 0} {
        set modified 0
        for {set i 0} {$i < [llength $disk_list]} {incr i} {
            if {[$disks state $i]} {
                set disk [lindex $disk_list $i]
                
                # XXX: this doesn't work very well since the current dialog
                # overrides the popup window
#                 ok_window $hui $dialog \
#                     [format "Writing disk %s" [$disk name]] \
#                     [format "Currently writing disk information to %s, please standby" [$disk name]] 0

                # XXX: we need to write the boot blocks too (Set_Boot_Blocks)
                # see sysinstall/disks.c:819
                if {[$disk Write_Disk]} {
                    ok_dialog $hui $dialog "Write failed" \
                        [format "Cannot write changes to disk %s" \
                             [$disk name]] "45 2"
                } else {
                    set modified 1
                }
            }
        }
        if {$modified} {
            return 1
        } else {
            return 0
        }
    } else {
        return 0
    }
}

proc valid_ops {chunk} {
    
    # all ops: NEWFS, NEWFS_F, MOUNT, ADD, RESIZE, DELETE
    switch [$chunk type] {
        # whole
        0 {
        }
        # unknown
        1 {
        }
        # fat
        2 {
            return {"MOUNT"}
        }
        # fbsd
        3 {
            return {"ADD"}
        }
        # extended
        4 {
        }
        # part
        5 {
            return {"DELETE", "MOUNT", "NEWFS", "NEWFS_F"}
        }
        # unused
        6 {
            return 0
        }
    }
}