source scripts/diskedit/dialogs.tcl
source scripts/diskedit/formats.tcl

# this is a hack, but it's not that bad.
#
# reuse methods from disklabel editor to recurse chunks and such
# ideally, those methods should be in a seperate file
source scripts/diskedit/disklabel.tcl

# maybe add a chunk to the given listbox
#
# level determines wether or not a "unused" part is displayed:
# if level < 2, it means that the unused part is not within a
# freebsd slice, so we should show it
proc display_chunk_r {listbox chunk level} {
    
    global sector_size

    if {[$chunk type] == 5 && [$chunk is_fs]} {
	$listbox add [$listbox numberOfItems] [newfs_format $chunk $sector_size]
    }
}

proc add_chunk {chunk {level 0}} {

    global parts_list
    global current_disk
    global part_to_disk_list
    if {[$chunk type] == 5 && [$chunk is_fs]} {
        lappend parts_list $chunk
        lappend part_to_disk_list $current_disk
    }
}

# main dialog creation code, should be called only once
proc newfs_win {hui parent} {
    global parts
    global disk_window
    global size_units

    set size_units "Mb"

    set disk_window [$hui dialog $parent "newfsdialog"\
                    "Format partitions" "1 0" "72 19" "vertical"]
    
    # parts section
    set parts [$disk_window listBox "partslistbox" "0 0" -1 \
                   "Available partitions"]
    
    set b [$disk_window button "units_but" "Cycle Si&ze Units ($size_units)" {cycle_units_callback ""}]
    $b resize "3 -1"
    set b [$disk_window button "toggle_but" "&Toggle format" {parts_callback TOGGLE}]
    $b resize "3 -1"
    set b [$disk_window button "write_but" "&Write" {parts_callback WRITE} "default"]
    $b resize "3 -1"

    # fill all this up
    read_disks
    refresh
    
    $disk_window exec

}

#
# callbacks
#

#
# we could also implement a "select" callback that would grey out some 
# impossible functions
#
proc parts_callback {hui button userdata} {

    global disk_window
    global parts_list
    global part_to_disk_list
    global disk_list
    global parts
    
    set chunk [lindex $parts_list [$parts select]]
    set disk [lindex $part_to_disk_list [$parts select]]
    set slice $chunk
    switch $userdata {
	"TOGGLE" {
            $chunk newfs [expr ![$chunk newfs]]
            refresh
	}
        "NEWFS_F" {
            # popup full newfs config window, with main newfs toggle along
            # with (possibly) multiple fields for the multiple flags
            puts "unimplemented"
        }
        "WRITE" {
	    if [newfs_parts_confirm $hui $disk_window $parts_list] {
		foreach part $parts_list {
		    if {[$part newfs] == 1} {
			if [catch {
			    exec "/sbin/newfs" [$part name]
			} err ] {
			    ok_dialog $hui $disk_window "Newfs failed" "newfs command failed with $err" "22 2"
			}
		    }
		}
	    }
	    return QUIT;
        }            
        default {
            puts "unkown callback: $userdata"
        }
    }
    return ""
}

proc newfs_parts_confirm {hui parent parts_list} {

    set dialog [$hui dialog $parent "newfs_parts_dialog" "Newfs parts"\
                    "10 6" "57 10" vertical]

    set label [$dialog label "desc label" "Really newfs those partitions?"]

    foreach part $parts_list {

	if {[$part newfs] == 1} {
	    $dialog label "l" [$part name]
	}
	
    }

    set okbutton [$dialog button "okbutton" "&OK" {button_click_result "OK"}]
    set cancelbutton [$dialog button "cancelbutton" "&Cancel" {button_click_result "CANCEL"}]

    $okbutton resize "10 2"
    $cancelbutton resize "10 2"

    $dialog exec
    set result [$dialog result]

    if {[string compare $result "OK"] == 0} {
	return 1
    } else {
        return 0
    }
}