#! /usr/bin/tclh

# $FreeBSD: libh/release/scripts/pkgtools/create_db.tcl,v 1.7 2002/06/03 15:31:09 antoine Exp $
#
# This script creates a new package database.
# Should only been run once, of course.

set dbpath [lindex $argv 0]

if {$dbpath != ""} {
    [Configuration] dbPath $dbpath
}

set allow [lindex $argv 1]
if {$allow == ""} {
    set allow [[DirectoriesAccess] allow]
}

lappend allow $dbpath
# Actually, this gives the slave interpreter write
# access to this directory
lappend allow "/opt"
[DirectoriesAccess] allow $allow

if [catch {set db [Database::create]} err] {
    puts stderr "Error: $err"
    exit 1
} else {
    set dbpath [$db dbPath]
    puts "Database created in $dbpath"
    puts "Adding /opt as default prefix..."
    [Configuration] prefix "/opt"
}

exit 0
