#!/usr/bin/tclh

# $FreeBSD: libh/release/scripts/pkgtools/file_by_name.tcl,v 1.5 2002/05/28 21:48:20 alex Exp $
#
# This file finds out if a file given as argument
# is recorded in the package database

set H_automatic_garbage_collection 0

# ----------------------------------------------------------------------

set db [Database]
for {set arg 0} {$arg < $argc} {incr arg} {
    puts stderr "[lindex $argv $arg]"
    set files [$db file [lindex $argv $arg]]
    if {[llength $files] == 0} {
	puts stderr "\tNo records for the file in the database"
    } else {
	foreach file $files {
	    puts stderr "\t[$file pathname] [$file length] [H::string_time_t [$file mtime]]"
	    set packages [$db packages_owning [lindex $argv $arg]]
	    if {[llength $packages] == 0} {
		puts stderr "\t\tNot owned"
	    } else {
		foreach package $packages {
		    puts stderr "\t\t[$package name]"
		}
	    }
	}
    }
}

exit 0

# ----------------------------------------------------------------------
