#! /usr/bin/tclh

# $FreeBSD: libh/release/scripts/pkgtools/pkg_info.tcl,v 1.6 2002/06/03 01:35:38 antoine Exp $
#
# This file prints out all info about a given package

set db [Database]

proc print_features { featurelist } {

    foreach feature $featurelist {
	puts [format "%12s\t%12s\t%12s\t%12s" [$feature name] [$feature version] [$feature serial] [$feature snapshot]]
    }

}

if {$argc == 0} {
    lappend argv "*"
}

foreach pkg [$db all_packages] {
    set match 0
    foreach pattern $argv {
	if {[string match $pattern [$pkg name]]} {
	    set match 1
	}
    }
    if {! $match} {
	continue
    }
    puts "Name: [$pkg name]"
    puts "Description: [[$pkg description] description]"
    puts "Summary: [[$pkg description] summary]"
    puts "Author: [[$pkg description] author]"
    puts "Files installed: [$pkg number_of_files]"
    puts "Installed on: [H::string_time_t [$pkg installation_time]]"

    puts "Conflicts:"
    print_features [$pkg conflicts]

    puts "Features:"
    puts [format "%12s\t%12s\t%12s\t%12s" "Name" "Version" "Serial" "Snapshot"]
    print_features [$pkg features]

    puts "Requires:"
    print_features [$pkg requires]

    if {[$pkg has_undo_info]} {
	puts "Package has undo info"
    }

    if {[$pkg has_uninstall_proc]} {
	puts "Package has uninstall proc"
    }

    puts ""
}
