# $FreeBSD: libh/release/scripts/setup.tcl,v 1.7 2002/04/14 00:13:10 antoine Exp $

set hui_type "auto"

# Init UI
set hui [Hui::open $hui_type]

# look for our source dir
proc scripts_dir {search_path} {
    
    foreach path $search_path  {
	if {[file isdirectory $path]} {
	    return $path
	}
    }
    return "."
}

global scripts_dir_path
set scripts_dir_path [scripts_dir [list "./scripts" "/etc/scripts"]]

proc next_callback {hui button user_data} {
    global functionslist
    global functionptr
    global main_window

    # XXX: hack. there *must* be a way to have "include paths"
    source scripts/diskedit/disklabel.tcl
    disklabel $hui $main_window

    source scripts/instmethod.tcl
    lappend functionslist "instmethod"

    incr functionptr
    instmethod
}

proc quit_callback {hui button user_data} {
    exit 0
}

# Create the main-window and its elements
proc make_main_win {} {
    global main_window
    global hui
    
    # Create a main_window with title, x/y offset and x/y size
    set main_window [$hui window main_window "FreeBSD Setup" "14 0" "50 20"] 
    set welcometext [$main_window textEdit welcometext "Welcome to FreeBSD!

This program will guide you through the
installation of FreeBSD.

Pressing 'Next' will get you to the next
configuration widget: the disk setup.
There you will choose where to install
FreeBSD and which disks to use.

Use 'Quit' to quit this setup program." FALSE]

    set next_button [$main_window button "inst_button" "&Next ->" {next_callback ""}]
    set quit_button [$main_window button "uninst_button" "&Quit" {quit_callback ""}]
    
    $welcometext resize "48 17"
    $quit_button resize "11 2"
    $next_button move "26 17"
    $quit_button move "37 17"
    $next_button resize "11 2"
    
    # Finally, show the window
    $main_window show
    
}

source scripts/commonvars.tcl

# Create the main-window
make_main_win

# Run hui
$hui run
