#ifndef BuildMake_hh_ba654856
#define BuildMake_hh_ba654856
/*
 * $Id: BuildMake.hh,v 1.6 2002/07/13 10:13:23 okumoto Exp $
 */
#include "Module.hh"

#include <map>
#include <string>

/**
 * Represents a project Makefile.  The modules that comprise the
 * project are ether descriptions of libraries or programs.  The
 * output is a Makefile fragment which builds contains all the
 * dependencies to generate the libraries and programs.  The
 * dependencies ether generated statically or dynamically when
 * running make.
 */
class BuildMake {
	typedef map<string, Module>	MList;

	const string	srcdir;	/**< current directory */
	const string	objdir;	/**< object directory */
	const bool	noisy;	/**< Makefile style */

	DirList		dirlist;	/**< list of input directories */
	MList		mlist;		/**< Module list */

public:
	BuildMake(
		const string &src, const string &obj,
		bool n,
		int count, const char * const dirs[]);

	void dirs(int count, const char * const dirs[]);

	void process();

	void output(ostream &out) const;
};

#endif /* BuildMake_hh_ba654856 */
