#ifndef Exceptions_hh_36679355
#define Exceptions_hh_36679355
/*
 * $Id: Exceptions.hh,v 1.1 2002/07/13 10:24:41 okumoto Exp $
 */
#include "ObjectCollection.hh"

#include <stdexcept>
#include <string>

/**
 * Represents a general error detected while processing input file.
 */
class Error : public runtime_error {
public:
    int line;		/**< line which contains error */
    string file;	/**< file which contains error */

    /**
     * Constructor.
     */
    Error(const string &what_arg, int pos, const string &filename)
        : runtime_error(what_arg), line(pos), file(filename) {}
};

/**
 * Represents a syntax error detected while processing input file.
 */
class SyntaxError : public Error {
public:
    /**
     * Constructor.
     */
    SyntaxError(const string &what_arg, int pos, const string &filename)
        : Error(what_arg, pos, filename) {}
};

#endif /* Exceptions_hh_36679355 */
