#ifndef MakeDependency_hh_516d5b90
#define MakeDependency_hh_516d5b90
/*
 * $Id: MakeDependency.hh,v 1.2 2002/07/07 05:06:51 okumoto Exp $
 */
#include <string>
#include <vector>

/**
 * Represents a Makefile dependency.
 */
class MakeDependency {
    typedef vector<string>	ValueList;

    string	target;
    string	action;
    ValueList	vl;

public:
    /**
     * Constructor.
     */
    MakeDependency(const string &t)
	: target(t)
    {
    }

    /**
     * Equivalence operator.
     */
    inline bool
    operator==(const MakeDependency &rhs) const
    {
	return target == rhs.target;
    }

    /**
     * LessThan operator.
     */
    inline bool
    operator<(const MakeDependency &rhs) const
    {
	return target < rhs.target;
    }

    inline void
    push_back(const string &data)
    {
	vl.push_back(data);
    }

    void
    set_action(const string &a)
    {
	action = a;
    }

    string
    output() const
    {
	string	result = target + ": ";

	for (ValueList::const_iterator i = vl.begin(); i != vl.end(); ++i) {
	    result += *i + " ";
	}
	result += "\n";

	if (action.empty() == false) {
	    result += action;
	}
	return result;
    }
};

#endif /* MakeDependency_hh_516d5b90 */
