#ifndef MakeVariable_hh_8f2e87e1
#define MakeVariable_hh_8f2e87e1
/*
 * $Id: MakeVariable.hh,v 1.2 2002/07/07 05:06:51 okumoto Exp $
 */
#include <string>
#include <vector>

/**
 * Represents a Makefile variable.
 */
class MakeVariable {
    typedef vector<string>	ValueList;

    string	prefix;
    string	base;
    string	suffix;
    ValueList	vl;

public:
    MakeVariable(const string &p, const string &b, const string &s)
	: prefix(p), base(b), suffix(s)
    {
    }

    inline void
    push_back(const string &data)
    {
	vl.push_back(data);
    }

    inline ValueList::size_type
    size() const
    {
	return vl.size();
    }

    inline string
    name() const
    {
	return prefix + '_' + base + '_' + suffix;
    }

    inline string
    assignment() const
    {
	return name() + " = " + list();
    }

    inline string
    value() const
    {
	return "${" + name() + "}";
    }

    string
    list() const
    {
	string	result;

	for (ValueList::const_iterator i = vl.begin(); i != vl.end(); ++i) {
	    result += *i + " ";
	}
	return result;
    }

};

#endif /* MakeVariable_hh_8f2e87e1 */
